﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;
using Microsoft.Http;

namespace OpenServicesSample
{
    public class GlobalFuncs
    {


        static public string EncodeTo64(string toEncode)
        {
            byte[] toEncodeAsBytes
                  = System.Text.ASCIIEncoding.ASCII.GetBytes(toEncode);
            string returnValue
                  = System.Convert.ToBase64String(toEncodeAsBytes);
            return returnValue;
        }

        static public string DecodeFrom64(string encodedData)
        {
            byte[] encodedDataAsBytes
                = System.Convert.FromBase64String(encodedData);
            string returnValue =
               System.Text.ASCIIEncoding.ASCII.GetString(encodedDataAsBytes);
            return returnValue;
        }


        public static string BuildResponseHtml(string requestString,
         HttpResponseMessage response, HttpRequestMessage request, string responseContent, bool error)
        {
            StringBuilder customMessage = new StringBuilder();

            string openP = "<p>";
            string closeP = "</p>";
            
            customMessage.Append(openP);
            customMessage.Append("Query string: ");                        
            customMessage.Append(requestString.ToString());
            customMessage.Append(closeP);
            customMessage.Append(openP);
            customMessage.Append(String.Format("Method: {0}", request.Method));            
            customMessage.Append(closeP);
            customMessage.Append(openP);
            customMessage.Append(String.Format("Status Code: {0} / {1}",
                response.StatusCode.GetHashCode(), response.StatusCode));
            customMessage.Append(closeP);

            if (error)
            {

                customMessage.Append(openP);
                customMessage.Append(String.Format("Error Message from Service: {0} ", responseContent));
                customMessage.Append(closeP);
            }
            

            customMessage.Append(openP);
            customMessage.Append(String.Format("Content Type: {0}", 
                response.Headers.ContentType));
            customMessage.Append(closeP);
            

            return customMessage.ToString();
        }
    }


}