﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using Microsoft.Http;
using System.Text;
using System.Xml.Serialization;
using System.ServiceModel.Web;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Xml;
using System.Xml.Linq;
using CROWS_ForPublicUse; // Use this if you refernec the DLL. Otherwise, create your own Company class.


namespace OpenServicesSample
{
    public partial class companysearch : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }


        protected void btnSearch_Click(object sender, EventArgs e)
        {
            try
            {

                
                repeater1.DataSource = null;
                repeater1.DataBind();

                AppSettingsReader r = new AppSettingsReader();

                string servicesUrl = r.GetValue("servicesUrl", typeof(string)).ToString();
                string apiKey = r.GetValue("apiKey", typeof(string)).ToString();
                string email = r.GetValue("memberEmailAddress", typeof(string)).ToString();

                HttpClient client = new HttpClient(servicesUrl);

                StringBuilder requestString = new StringBuilder();

                requestString.Append(String.Format("companies?"));
                requestString.Append(txtCompanyNum.Text.Trim() == "" ? "" : String.Format("&company_num={0}", txtCompanyNum.Text));
                requestString.Append(txtCompanyName.Text.Trim() == "" ? "" : String.Format("&company_name={0}", txtCompanyName.Text));
                requestString.Append(txtAlpha.Text.Trim() == "" ? "" : String.Format("&alpha={0}", txtAlpha.Text));
                requestString.Append(txtcompanyBusInd.Text.Trim() == "" ? "" : String.Format("&company_bus_ind={0}", txtcompanyBusInd.Text));
                requestString.Append(txtAddress.Text.Trim() == "" ? "" : String.Format("&address={0}", txtAddress.Text));
                requestString.Append(txtSkip.Text.Trim() == "" ? "&skip=0" : String.Format("&skip={0}", txtSkip.Text));
                requestString.Append(txtMax.Text.Trim() == "" ? "&max=5" : String.Format("&max={0}", txtMax.Text));
                requestString.Append("&htmlEnc=1");

                string fullUrl = HttpUtility.HtmlEncode(String.Format("{0}{1}",
                    servicesUrl, requestString.ToString()));


                using (HttpRequestMessage request = new HttpRequestMessage("GET",
                           requestString.ToString()))
                {

                    request.Headers.Add("Authorization", string.Format("Basic {0}",
                      GlobalFuncs.EncodeTo64(
                      String.Format("{0}:{1}", email, apiKey))));


                    // This is optional.  If you do not specify this, xml will be assumed.                    
                    if (radioFormat.SelectedValue == "Xml")
                    {
                        request.Headers.Accept.AddString("application/xml");
                    }
                    else
                    {
                        // This is the other approach to getting Json data if you don't want to 
                        // include "&format=json" in the query string:
                        request.Headers.Accept.AddString("application/json");
                    }


                    using (HttpResponseMessage response = client.Send(request))
                    {

                        string responseContent = "";

                        try
                        {

                            response.Content.LoadIntoBuffer();

                            if (response.StatusCode != System.Net.HttpStatusCode.OK)
                            {

                                // response.Content will be disposed of when we try to access the message 
                                // later on, so get it now, display later... 
                                responseContent = response.Content.ReadAsString();

                                if (!response.Content.ContentType.StartsWith("application/xml;"))
                                {
                                    // Don't let this happen in your app!  
                                    // Be careful not to display a message through a browser
                                    // if you called the service using an invalid endpoint.  only
                                    // look for xml error messages:
                                    responseContent = "Invalid Endpoint - Check the way you are calling the service";
                                }
                               
                            }

                            response.EnsureStatusIsSuccessful();

                            // for display purposes to show you the full results...
                            literalResponse.Text = GlobalFuncs.BuildResponseHtml(
                                fullUrl,
                                response,
                                request,
                                "",
                                false);

                            response.Content.LoadIntoBuffer();


                            List<Company> list = new List<Company>();

                            if (radioFormat.SelectedValue == "Xml")
                            {

                                txtResponse.Text = response.Content.ReadAsXElement().ToString();

                                // If you want to serialize into a List of type Company :
                                //          List<Company> list = response.Content.ReadAsDataContract<List<Company>>();
                                list = response.Content.ReadAsDataContract<List<Company>>();

                            }

                            else
                            {

                                txtResponse.Text = response.Content.ReadAsString();

                                // If you want to load Json into a List of type Company :
                                //          List<Company> list = response.Content.ReadAsDataContract<List<Company>>();
                                list = response.Content.ReadAsJsonDataContract<List<Company>>();

                            }

                            repeater1.DataSource = list;

                            repeater1.DataBind();

                            response.Content.Dispose();


                        }

                        catch (Exception responseEx)
                        {

                            literalResponse.Text = GlobalFuncs.BuildResponseHtml(fullUrl,
                                response, request,responseContent,  true);

                            txtResponse.Text = String.Format(
                                "Exception message thrown from service: {0} ",
                                responseEx.Message);

                        }


                    }


                }


            }
            catch (Exception ex)
            {
                StringBuilder error = new StringBuilder();
                error.AppendLine("Exception occured");
                error.AppendLine(ex.Message);
                txtResponse.Text = error.ToString();
            }
        }


      

    }
}