﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using Microsoft.Http;
using System.Configuration;
using System.Xml.Serialization;
using System.ServiceModel.Web;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Xml.Linq;
using CROWS_ForPublicUse;   // import CROWS.dll or create your own class... 

namespace OpenServicesSample
{
    public partial class onecompany : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }



        protected void btnGetDetails_Click(object sender, EventArgs e)
        {

            try
            {


                AppSettingsReader r = new AppSettingsReader();
                
                string servicesUrl = r.GetValue("servicesUrl", typeof(string)).ToString();
                string apiKey = r.GetValue("apiKey", typeof(string)).ToString();
                string email = r.GetValue("memberEmailAddress", typeof(string)).ToString();

                HttpClient client = new HttpClient(servicesUrl);

                StringBuilder requestString = new StringBuilder();

                requestString.Append(String.Format("company/{0}/{1}", txtCompanyNum.Text, txtcompanyBusInd.Text));


                using (HttpRequestMessage request = new HttpRequestMessage("GET",
                           requestString.ToString()))
                {


                    request.Headers.Add("Authorization", string.Format("Basic {0}",
                      GlobalFuncs.EncodeTo64(
                      String.Format("{0}:{1}", email, apiKey))));

                    // This is optional.  If you do not specify this, xml will be assumed.                    
                    if (radioFormat.SelectedValue == "Xml")
                        request.Headers.Accept.AddString("application/xml");
                    else
                        // This is the other approach to getting Json data if you don't want to 
                        // include "&format=json" in the query string:
                        request.Headers.Accept.AddString("application/json");


                    string fullUrl = String.Format("{0}{1}", servicesUrl, requestString.ToString());


                    using (HttpResponseMessage response = client.Send(request))
                    {


                        string responseContent = "";

                        try
                        {

                            response.Content.LoadIntoBuffer();

                            if (response.StatusCode != System.Net.HttpStatusCode.OK)
                            {

                                // response.Content will be disposed of when we try to access the message 
                                // later on, so get it now, display later... 
                                responseContent = response.Content.ReadAsString();

                                if (!response.Content.ContentType.StartsWith("application/xml;"))
                                {
                                    // Don't let this happen in your app!  
                                    // Be careful not to display a message through a browser
                                    // if you called the service using an invalid endpoint.  only
                                    // look for xml error messages:
                                    responseContent = "Invalid Endpoint - Check the way you are calling the service";
                                }
                                
                            }    

                            response.EnsureStatusIsSuccessful();

                            // for display purposes to show you the full results...
                            literalResponse.Text = GlobalFuncs.BuildResponseHtml(
                                fullUrl,
                                response,
                                request,
                                "",
                                false);

                            response.Content.LoadIntoBuffer();

                            if (radioFormat.SelectedValue == "Xml")
                            {
                                // Nicely formatted XML
                                txtResponse.Text = response.Content.ReadAsXElement().ToString();

                                // Or to load into a Company object do this:
                                //         Company c = response.Content.ReadAsDataContract<Company>();

                            }
                            else
                            {

                                //Actual text returned would be:
                                txtResponse.Text = response.Content.ReadAsString();

                                // Or to load into a Company object do this:
                                //          Company c= response.Content.ReadAsJsonDataContract<Company>();

                            }


                            response.Content.Dispose();

                        }
                        catch (Exception responseEx)
                        {

                            literalResponse.Text = GlobalFuncs.BuildResponseHtml(fullUrl,
                                response, request, responseContent, true);

                            txtResponse.Text = String.Format(
                                "Exception message thrown from service: {0} ",
                                responseEx.Message);

                        }


                    }

                }


            }
            catch (Exception ex)
            {
                StringBuilder error = new StringBuilder();
                error.AppendLine("Exception occured");
                error.AppendLine(ex.Message);
                txtResponse.Text = error.ToString();
            }
        }

    }
}