﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using Microsoft.Http;
using System.Text;
using System.ServiceModel.Web;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Collections.Specialized;
using CROWS_ForPublicUse;


namespace OpenServicesSample
{
    public partial class paging : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Page_PreRender(object sender, EventArgs e)
        {

            if (!IsPostBack)
            {

                try
                {


                    string defaultSortClause = "sub_num,desc-doc_num,asc";

                    NameValueCollection values = Request.QueryString;

                    // Just use the text box values for first load... 
                    string companyNum = values["company_num"] == null ? txtCompanyNum.Text : values["company_num"].ToString();
                    string companyBusInd = values["company_bus_ind"] == null ? txtcompanyBusInd.Text : values["company_bus_ind"].ToString();
                    
                    string _skip = values["skip"] == null ? "0" : values["skip"].ToString();
                    string _maxRows = values["max"] == null ? "5" : values["max"].ToString();
                    string _sort = values["sort"] == null ? defaultSortClause : values["sort"].ToString();

                    int max = 5;
                    if (!Int32.TryParse(_maxRows, out max)) max = 5;

                    int skip = 0;
                    if (!Int32.TryParse(_skip, out skip)) skip = 0;


                    string[] sortDirectionOpts = { "asc", "desc" };
                    ddSort1.DataSource = SubmissionDoc.OrderByColumnNames;
                    ddSort1.DataBind();
                    ddSort1Dir.DataSource = sortDirectionOpts;
                    ddSort1Dir.DataBind();
                    ddSort2.DataSource = SubmissionDoc.OrderByColumnNames;
                    ddSort2.DataBind();
                    ddSort2Dir.DataSource = sortDirectionOpts;
                    ddSort2Dir.DataBind();

                    // Force selection of drop downs, assuming that the column specified is valid
                    string[] sortSplit = _sort.Split('-');
                    int sortPart = 1;
                    foreach (string clause in sortSplit)
                    {

                        string[] clauseParts = clause.Split(',');
                        if (clauseParts.Length != 2)
                        {
                            // Reset and stick to the default search options as there is an invalid 
                            // column and asc/desc clause specified:
                            _sort = defaultSortClause;
                            // Force selection of sub_num desc, doc_num asc
                            ResetDropDownDefaults();
                            break;
                        }
                        else
                        {
                            if (SubmissionDoc.OrderByColumnNames.Contains(clauseParts[0]) && (clauseParts[1] == "asc" || clauseParts[1] == "desc"))
                            {
                                if (sortPart == 1)
                                {
                                    ddSort1.SelectedIndex = SubmissionDoc.OrderByColumnNames.ToList<string>().IndexOf(clauseParts[0]);
                                    int direction = clauseParts[1] == "asc" ? 0 : 1;
                                    ddSort1Dir.SelectedIndex = direction;
                                }
                                else if (sortPart == 2)
                                {
                                    ddSort2.SelectedIndex = SubmissionDoc.OrderByColumnNames.ToList<string>().IndexOf(clauseParts[0]);
                                    int direction = clauseParts[1] == "asc" ? 0 : 1;
                                    ddSort2Dir.SelectedIndex = direction;
                                }
                                // all other sort parts ignored for demo purposes... 

                            }
                            else
                            {
                                // else... there are invalid values in the query string
                                // so just ignore everything and reset the sort... 
                                _sort = defaultSortClause;
                                ResetDropDownDefaults();
                            }
                        }

                        sortPart++;

                    }


                    RunQuery(companyNum, companyBusInd, skip, max,
                        ddSort1.Text, ddSort1Dir.Text, ddSort2.Text, ddSort2Dir.Text);

                    txtMax.Text = _maxRows;
                    txtSkip.Text = _skip;

                }
                catch (Exception ex)
                {
                    //StringBuilder error = new StringBuilder();
                    //error.AppendLine("Exception occured");
                    //error.AppendLine(ex.Message);
                    lblError.Text = "Error - check your parameters. Remember this page only works for company number " + txtCompanyNum.Text;

                }

            }
        }

        private void ResetDropDownDefaults()
        {
            ddSort1.SelectedIndex = SubmissionDoc.OrderByColumnNames.ToList<string>().IndexOf("sub_num");
            ddSort1Dir.SelectedIndex = 1;
            ddSort2.SelectedIndex = SubmissionDoc.OrderByColumnNames.ToList<string>().IndexOf("doc_num");
            ddSort2Dir.SelectedIndex = 2;
        }


        private void RunQuery(string companyNum, string companyBusInd,
            int skip, int maxRows, string sortBy1, string sortDir1,
            string sortBy2, string sortDir2)
        {

            AppSettingsReader r = new AppSettingsReader();
            string apiKey = r.GetValue("apiKey", typeof(string)).ToString();
            string email = r.GetValue("memberEmailAddress", typeof(string)).ToString();

            string servicesUrl = r.GetValue("servicesUrl", typeof(string)).ToString();           

            repeater1.DataSource = null;
            repeater1.DataBind();

            HttpClient client = new HttpClient(servicesUrl);

            StringBuilder requestStringCount = new StringBuilder();
            requestStringCount.Append("submissionCount?");
            requestStringCount.Append(String.Format("company_num={0}", companyNum));
            requestStringCount.Append(String.Format("&company_bus_ind={0}", companyBusInd));

            Int32 totalRecordCount = 0;

            using (HttpRequestMessage request = new HttpRequestMessage("GET",
                       requestStringCount.ToString()))
            {


                request.Headers.Add("Authorization", string.Format("Basic {0}",
                  GlobalFuncs.EncodeTo64(
                  String.Format("{0}:{1}", email, apiKey))));


                request.Headers.Accept.AddString("application/xml");

                using (HttpResponseMessage response = client.Send(request))
                {
                    try
                    {
                        response.EnsureStatusIsSuccessful();
                        response.Content.LoadIntoBuffer();

                        totalRecordCount = response.Content.ReadAsDataContract<Int32>();
                        response.Content.Dispose();
                    }
                    catch (Exception responseEx)
                    {
                        lblError.Text = responseEx.ToString();
                    }
                }
            }



            StringBuilder requestString = new StringBuilder();
            requestString.Append("submissions?");
            requestString.Append(String.Format("company_num={0}", companyNum));
            requestString.Append(String.Format("&company_bus_ind={0}", companyBusInd));
            requestString.Append(String.Format("&skip={0}", skip));
            requestString.Append(String.Format("&max={0}", maxRows));

            // Remember the sort criteria is not necessary... see documentation on default sorts.
            requestString.Append(String.Format("&sortBy1={0}", sortBy1));
            requestString.Append(String.Format("&sortDir1={0}", sortDir1));
            requestString.Append(String.Format("&sortBy2={0}", sortBy2));
            requestString.Append(String.Format("&sortDir2={0}", sortDir2));
            
            requestString.Append("&htmlEnc=1");


            string fullUrl = HttpUtility.HtmlEncode(String.Format("{0}{1}",
                servicesUrl, requestString.ToString()));


            using (HttpRequestMessage request = new HttpRequestMessage("GET",
                       requestString.ToString()))
            {


                request.Headers.Add("Authorization", string.Format("Basic {0}",
                  GlobalFuncs.EncodeTo64(
                  String.Format("{0}:{1}", email, apiKey))));


                request.Headers.Accept.AddString("application/xml");

                using (HttpResponseMessage response = client.Send(request))
                {
                    try
                    {
                        // Throw an exeption if call was unsuccessful...
                        response.EnsureStatusIsSuccessful();
                        response.Content.LoadIntoBuffer();
                        List<SubmissionDoc> list = new List<SubmissionDoc>();

                        list = response.Content.ReadAsDataContract<List<SubmissionDoc>>();
                        repeater1.DataSource = list;
                        repeater1.DataBind();
                        response.Content.Dispose();
                    }
                    catch (Exception ex)
                    {
                        throw new Exception(ex.Message);
                    }
                }
            }




            // We have the total number of matches.
            // We can create as many links as we need to get the paging to work...
            #region Build Links

            int pageCount = totalRecordCount / maxRows;
            if (totalRecordCount % maxRows > 0)
            {
                pageCount++;    //Need one extra page
            }

            //Create a simple href... 
            int currentSkip = 0;

            StringBuilder hrefs = new StringBuilder("<div id=\"pdLinks\">");
            for (int page = 1; page <= pageCount; page++)
            {
                StringBuilder ahref = new StringBuilder();

                if (currentSkip == skip)
                {
                    // If we are currently looking at the relevant page, don't bother creating a link.
                    // Just display the page number
                    ahref.Append(String.Format("<span>{0}</span>", page));
                }
                else
                {
                    //create a link
                    ahref.Append("<a href=\"");
                    StringBuilder linkString = new StringBuilder();

                    // for demo purposes we need force page refresh; use Ajax using your own implementation... 
                    linkString.Append("javascript:window.location='/paging.aspx?");

                    linkString.Append(String.Format("company_num={0}", companyNum));
                    linkString.Append(String.Format("&company_bus_ind={0}", companyBusInd));
                    linkString.Append(String.Format("&skip={0}", currentSkip));
                    linkString.Append(String.Format("&max={0}", maxRows));
                    linkString.Append(String.Format("&sortBy1={0}", sortBy1));
                    linkString.Append(String.Format("&sortDir1={0}", sortDir1));
                    linkString.Append(String.Format("&sortBy2={0}", sortBy2));
                    linkString.Append(String.Format("&sortDir2={0}", sortDir2));
                    linkString.Append("'");

                    ahref.Append(HttpUtility.HtmlEncode(linkString.ToString()));

                    ahref.Append("\" >");
                    ahref.Append(page.ToString());
                    ahref.AppendLine("</a>");
                }

                hrefs.Append(ahref.ToString());


                currentSkip = currentSkip + maxRows;
            }

            hrefs.AppendLine("</div>");

            literalPaging.Text = hrefs.ToString();

            #endregion


        }


        protected void btnRun_Click(object sender, EventArgs e)
        {

            try
            {

                literalPaging.Text = "";

                NameValueCollection values = Request.QueryString;
                string companyNum = txtCompanyNum.Text;
                string companyBusInd = txtcompanyBusInd.Text;


                int max = 5;
                if (!Int32.TryParse(txtMax.Text, out max))
                {
                    max = 5;
                    txtMax.Text = max.ToString();
                }


                int skip = 0;
                if (!Int32.TryParse(txtSkip.Text, out skip))
                {
                    skip = 0;
                    txtSkip.Text = skip.ToString();
                }


                RunQuery(companyNum, companyBusInd, skip, max,
                    ddSort1.Text, ddSort1Dir.Text, ddSort2.Text, ddSort2Dir.Text);


            }
            catch (Exception ex)
            {
                lblError.Text = ex.Message;
            }

        }

    }

}